summaryrefslogtreecommitdiffstats
path: root/alsa-plugins
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2013-12-26 23:45:55 +0000
committer Eric Hameleers <alien@slackware.com>2013-12-26 23:45:55 +0000
commitaf3bbc09f8415a17d180ccea1e1502e313bc51ad (patch)
tree9433129ff14633b3aa9dcce6157b66048a7c0c2a /alsa-plugins
parent03448d5770a82a220169e2b8842f4f8e257c56ea (diff)
downloadasb-af3bbc09f8415a17d180ccea1e1502e313bc51ad.tar.gz
asb-af3bbc09f8415a17d180ccea1e1502e313bc51ad.tar.xz
Initial revision
Diffstat (limited to 'alsa-plugins')
-rwxr-xr-xalsa-plugins/build/alsa-plugins.SlackBuild226
-rw-r--r--alsa-plugins/build/patches/alsa-plugins_ffmpeg_headers.patch54
-rw-r--r--alsa-plugins/build/patches/alsa-plugins_ffmpeg_version.patch14
-rw-r--r--alsa-plugins/build/slack-desc20
-rw-r--r--alsa-plugins/build/slack-required3
5 files changed, 317 insertions, 0 deletions
diff --git a/alsa-plugins/build/alsa-plugins.SlackBuild b/alsa-plugins/build/alsa-plugins.SlackBuild
new file mode 100755
index 00000000..8c14ecc9
--- /dev/null
+++ b/alsa-plugins/build/alsa-plugins.SlackBuild
@@ -0,0 +1,226 @@
+#!/bin/sh
+# $Id$
+# Copyright 2013 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: alsa-plugins
+# Descr: ALSA extra plugins
+# URL: http://www.alsa-project.org/
+# Build needs:
+# Needs: ffmpeg,jack
+# Changelog:
+# 1.0.27-1: 26/Dec/2013 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh alsa-plugins.SlackBuild' to build a Slackware package.
+# The package (.txz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=alsa-plugins
+VERSION=${VERSION:-1.0.27}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
+
+DOCS="COPYING* doc/README* doc/*.txt"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.bz2"
+SRCURL="http://alsa.cybermirror.org/plugins/${PRGNAM}-${VERSION}.tar.bz2"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+MARCH=$( uname -m )
+if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i486 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ armv6hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+fi
+
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ armv6hl) SLKCFLAGS="-O2 -march=armv6 -mfpu=vfp -mfloat-abi=hard"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}
+
+# Allow the use of a recent ffmpeg:
+touch $OUTPUT/patch-${PRGNAM}.log
+cat $SRCDIR/patches/${PRGNAM}_ffmpeg_version.patch | patch -p1 --verbose \
+ 2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+X-s .
+
+echo Building ...
+LDFLAGS="$SLKLDFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --with-speex=builtin \
+ --program-prefix= \
+ --program-suffix= \
+ --build=$TARGET \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Thanks to PhantomX for these ALSA configuration files,
+# see https://github.com/PhantomX/slackbuilds/ :
+mkdir -p ${PKG}/usr/share/alsa/alsa.conf.d
+for CONF in $SRCDIR/alsaconf/*.conf.gz ; do
+ zcat $CONF > ${PKG}/usr/share/alsa/alsa.conf.d/$(basename ${CONF} .gz)
+done
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/alsa-plugins/build/patches/alsa-plugins_ffmpeg_headers.patch b/alsa-plugins/build/patches/alsa-plugins_ffmpeg_headers.patch
new file mode 100644
index 00000000..86026d48
--- /dev/null
+++ b/alsa-plugins/build/patches/alsa-plugins_ffmpeg_headers.patch
@@ -0,0 +1,54 @@
+diff -ru alsa-plugins-1.0.17.orig/a52/pcm_a52.c alsa-plugins-1.0.17/a52/pcm_a52.c
+--- alsa-plugins-1.0.17.orig/a52/pcm_a52.c 2008-08-06 18:28:39.000000000 +0200
++++ alsa-plugins-1.0.17/a52/pcm_a52.c 2008-08-06 18:28:54.000000000 +0200
+@@ -18,6 +18,7 @@
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ */
+
++#include "config.h"
+ #include <stdio.h>
+ #include <string.h>
+ #define __USE_XOPEN
+@@ -25,7 +26,11 @@
+ #include <alsa/asoundlib.h>
+ #include <alsa/pcm_external.h>
+ #include <alsa/pcm_plugin.h>
++#ifdef HAVE_FFMPEG_AVCODEC_H
+ #include <ffmpeg/avcodec.h>
++#elif defined(HAVE_LIBAVCODEC_AVCODEC_H)
++#include <libavcodec/avcodec.h>
++#endif
+
+ struct a52_ctx {
+ snd_pcm_ioplug_t io;
+diff -ru alsa-plugins-1.0.17.orig/configure.in alsa-plugins-1.0.17/configure.in
+--- alsa-plugins-1.0.17.orig/configure.in 2008-08-06 18:28:39.000000000 +0200
++++ alsa-plugins-1.0.17/configure.in 2008-08-06 18:31:00.000000000 +0200
+@@ -77,7 +77,7 @@
+ if test "x$enable_avcodec" != "xno"; then
+ AC_CHECK_LIB([avcodec], [avcodec_open], [HAVE_AVCODEC=yes], [HAVE_AVCODEC=no])
+ if test x$HAVE_AVCODEC = xyes; then
+- AC_CHECK_HEADER([ffmpeg/avcodec.h], [], [HAVE_AVCODEC=no])
++ AC_CHECK_HEADERS([ffmpeg/avcodec.h], , [AC_CHECK_HEADERS([libavcodec/avcodec.h], , [HAVE_AVCODEC=no])])
+ fi
+ fi
+ AM_CONDITIONAL(HAVE_AVCODEC, test x$HAVE_AVCODEC = xyes)
+diff -ru alsa-plugins-1.0.17.orig/rate-lavc/rate_lavcrate.c alsa-plugins-1.0.17/rate-lavc/rate_lavcrate.c
+--- alsa-plugins-1.0.17.orig/rate-lavc/rate_lavcrate.c 2008-08-06 18:28:39.000000000 +0200
++++ alsa-plugins-1.0.17/rate-lavc/rate_lavcrate.c 2008-08-06 18:28:54.000000000 +0200
+@@ -16,10 +16,15 @@
+ * Lesser General Public License for more details.
+ */
+
++#include "config.h"
+ #include <stdio.h>
+ #include <alsa/asoundlib.h>
+ #include <alsa/pcm_rate.h>
++#ifdef HAVE_FFMPEG_AVCODEC_H
+ #include <ffmpeg/avcodec.h>
++#elif defined(HAVE_LIBAVCODEC_AVCODEC_H)
++#include <libavcodec/avcodec.h>
++#endif
+ #include "gcd.h"
+
+ static int filter_size = 16;
diff --git a/alsa-plugins/build/patches/alsa-plugins_ffmpeg_version.patch b/alsa-plugins/build/patches/alsa-plugins_ffmpeg_version.patch
new file mode 100644
index 00000000..76b3716d
--- /dev/null
+++ b/alsa-plugins/build/patches/alsa-plugins_ffmpeg_version.patch
@@ -0,0 +1,14 @@
+# Fixes building against FFmpeg version >= 2.0.0
+
+diff -Naur alsa-plugins-1.0.27.orig/a52/pcm_a52.c alsa-plugins-1.0.27/a52/pcm_a52.c
+--- alsa-plugins-1.0.27.orig/a52/pcm_a52.c 2013-04-11 13:43:08.000000000 +0200
++++ alsa-plugins-1.0.27/a52/pcm_a52.c 2013-10-08 12:08:24.811631662 +0200
+@@ -27,7 +27,7 @@
+ #include <alsa/pcm_plugin.h>
+ #include AVCODEC_HEADER
+
+-#if LIBAVCODEC_VERSION_MAJOR >= 53 && LIBAVCODEC_VERSION_MINOR >= 34
++#if LIBAVCODEC_VERSION_INT >= AV_VERSION_INT(53,34,0)
+ #include <libavutil/audioconvert.h>
+ #include <libavutil/mem.h>
+ #define USE_AVCODEC_FRAME
diff --git a/alsa-plugins/build/slack-desc b/alsa-plugins/build/slack-desc
new file mode 100644
index 00000000..9aa40c59
--- /dev/null
+++ b/alsa-plugins/build/slack-desc
@@ -0,0 +1,20 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+alsa-plugins: alsa-plugins (ALSA extra plugins)
+alsa-plugins:
+alsa-plugins: These plugins are used to create virtual devices that can be used
+dependencies. like normal hardware devices but cause extra processing of the
+alsa-plugins: sound stream to take place.
+alsa-plugins: They are used while configuring ALSA in the .asoundrc file.
+alsa-plugins: Plugins for ffmpeg, speex, jack are included.
+alsa-plugins:
+alsa-plugins:
+alsa-plugins:
+alsa-plugins: alsa-plugins home: http://www.alsa-project.org/
+alsa-plugins:
diff --git a/alsa-plugins/build/slack-required b/alsa-plugins/build/slack-required
new file mode 100644
index 00000000..dde1175c
--- /dev/null
+++ b/alsa-plugins/build/slack-required
@@ -0,0 +1,3 @@
+ffmpeg
+jack
+